podTemplate(
    inheritFrom: 'jenkins-slave',
    containers: [
        containerTemplate(name: 'maven', image: 'maven:3.8.6-openjdk-11-slim', ttyEnabled: true, command: 'cat'),
        containerTemplate(name: 'docker', image: 'docker:24.0.5-dind', ttyEnabled: true, command: 'cat'),
        containerTemplate(
          name: 'kubectl',
          image: 'alpine/k8s:1.24.13',
          command:'cat',
          ttyEnabled: true,
          privileged: true
          )
    ],
    volumes: [
                    hostPathVolume(hostPath: '/var/run/docker.sock', mountPath: '/var/run/docker.sock')
    ]
){
    node(POD_LABEL){
        stage("checkout code"){
            checkout scm
        }
        stage("testing docker login"){
            container('docker'){
                sh 'docker login -u hazgui -p canisayhi?'
            }
        }
        stage("Build JAR file of the project"){
            container('maven'){
                sh 'mvn clean install'
            }
        }

        stage("Build docker file"){
            container('docker'){
                sh 'docker build . -t simple-image'
            }
        }

        stage("Push docker image to dockerhub"){
            container('docker'){
                environment{
                    DOCKERHUB_CREDENTIALS = credentials('docker_hub')
                }
                withCredentials([usernamePassword(credentialsId: 'docker_hub',  usernameVariable:'DOCKERHUB_CREDENTIALS_USR', passwordVariable:'DOCKERHUB_CREDENTIALS_PSW')]){
                    sh 'docker tag simple-image hazgui/simple-image'
                    sh 'docker push hazgui/simple-image'
            }                
        }
        }


        stage("Deployment"){
            container('kubectl'){
                withCredentials([file(credentialsId: 'kube_file',variable:'KUBECONFIG')]) {
                    sh 'kubectl apply -f deployment.yaml'
                    sh ' kubectl apply -f service.yaml'
                    sh ' kubectl apply -f ingress.yaml'
            }}
        }

    }
}